//rational header

#ifndef RATIONAL_H //if not defined
#define RATIONAL_H //define
#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <regex>
#include "limits.h"
using namespace std;

class rational{
private:
	int numerator;
	int denominator;

public:
	rational();//default constructor
	rational::rational(string rationalIn);//for the calculator
	rational(int numeratorIn, int denominatorIn);//for n/n
	rational(int numeratorIn);//for n/1
	rational normalize(rational toNormalize);//normalization
	int gcf(int a, int b);//greatest common factor (for normalization and LCM)
	int lcm(int a, int b);//least common multiple (for addition and subtraction - must have like denominators)
	bool operator<(rational &r1);//overloaded comparison operators
	bool operator>(rational &r1);
	bool operator==(rational &r1);
    friend void operator>> (istream& input, rational &r1);//input operator
	int rational::string2Int(string numberIn);//for making integers of strings
	friend ostream& operator<< (ostream &output, rational &r1);//output operator
	string toString(rational r1);//makes rationals into strings
	string int2String(int a);//for making strings of integers
	rational operator+(rational &r1);//overloaded arith operators
    rational operator-(rational &r1);
	rational operator*(rational &r1);
	rational operator/(rational &r1);
	friend std::vector<std::string> &split(const std::string &s, char delim, std::vector<std::string> &elems); //called by split,
	//needed to split strings
	friend std::vector<std::string> split(const std::string &s, char delim); //calls &split, called by >>, needed to split strings
	bool isAdditionSafe(int a, int b);//prevent integer overflow
	bool isMultiplicationSafe(int a, int b);
	virtual ~rational(); //virtual destructor
};

#endif